Debian Bug report logs - #477751
dh_installcatalogs: Don't readd catalog on every upgrade to the catalog

version graph

Package: debhelper; Maintainer for debhelper is Debhelper Maintainers <debhelper-devel@lists.alioth.debian.org>; Source for debhelper is src:debhelper.

Reported by: Jörg Sommer <joerg@alea.gnuu.de>

Date: Fri, 25 Apr 2008 00:45:04 UTC

Severity: serious

Tags: lenny-ignore, patch, squeeze-ignore

Merged with 88010

Fixed in version debhelper/9.20120528

Done: Joey Hess <joeyh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package docbook-xml. Full text and rfc822 format available.

Acknowledgement sent to Jörg Sommer <joerg@alea.gnuu.de>:
New Bug report received and forwarded. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jörg Sommer <joerg@alea.gnuu.de>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: docbook-xml: Don't readd your catalog on every upgrade to the super catalog
Date: Fri, 25 Apr 2008 00:35:06 +0200
[Message part 1 (text/plain, inline)]
Package: docbook-xml
Version: 4.5-5
Severity: serious
Justification: Policy 10.7.3

Hi,

policy says, you should preserve user changes during upgrades. When I
remove the catalog from the super file by running “update-catalog
--remove --super /etc/sgml/docbook-xml.cat” my changes are lost after an
upgrade, because you readd the catalog.

Bye, Jörg.

-- System Information:
Debian Release: unstable/experimental
  APT prefers unstable
  APT policy: (900, 'unstable'), (700, 'experimental')
Architecture: powerpc (ppc)

Kernel: Linux 2.6.25
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages docbook-xml depends on:
ii  sgml-base                     1.26       SGML infrastructure and SGML catal
ii  sgml-data                     2.0.3      common SGML and XML data
ii  xml-core                      0.11       XML infrastructure and XML catalog

docbook-xml recommends no packages.

-- no debconf information
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package docbook-xml. Full text and rfc822 format available.

Acknowledgement sent to Daniel Leidert <daniel.leidert@wgdd.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 477751@bugs.debian.org (full text, mbox):

From: Daniel Leidert <daniel.leidert@wgdd.de>
To: 477751@bugs.debian.org, control@bugs.debian.org
Cc: 477751-submitter@bugs.debian.org
Subject: Re: Bug#477751: dh_installcatalogs: Don't readd catalog on every upgrade to the super catalog
Date: Sat, 26 Apr 2008 01:13:25 +0200
reassign 477751 debhelper
retitle 477751 dh_installcatalogs: Don't readd catalog on every upgrade to the super catalog
thanks

Am Freitag, den 25.04.2008, 00:35 +0200 schrieb Jörg Sommer:
> Package: docbook-xml
> Version: 4.5-5
> Severity: serious
> Justification: Policy 10.7.3
> 
> Hi,
> 
> policy says, you should preserve user changes during upgrades. When I
> remove the catalog from the super file by running “update-catalog
> --remove --super /etc/sgml/docbook-xml.cat” my changes are lost after an
> upgrade, because you readd the catalog.

Seems you are not satisfied, how dh_installcatalogs works. Reassigning.
Will have a look at dh_installcatalogs in 2 weeks, when I'm back.

Regards, Daniel





Bug reassigned from package `docbook-xml' to `debhelper'. Request was from Daniel Leidert <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Fri, 25 Apr 2008 23:18:03 GMT) Full text and rfc822 format available.

Message sent on to Jörg Sommer <joerg@alea.gnuu.de>:
Bug#477751. Full text and rfc822 format available.

Changed Bug title to `dh_installcatalogs: Don't readd catalog on every upgrade to the catalog' from `docbook-xml: Don't readd your catalog on every upgrade to the super catalog'. Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Sat, 26 Apr 2008 00:27:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #22 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: 477751@bugs.debian.org
Subject: why it's added on upgrade
Date: Sun, 4 May 2008 17:18:18 -0400
[Message part 1 (text/plain, inline)]
See #209131 for why update-catalog is run on upgrade.

The infelicity is in the design of update-catalog. If catalogs are not
removed and re-added on upgrade, then if a package's catalogs change on
upgrade, the old ones will not be removed from the catalog file, and new
ones won't be added.

I could change dh_installcatalogs, but would be inviting packages that
use it to break in the future by doing so. It would be better to change
update-catalog to use an interface for catalog registration similar to
the ones used by update-menus, update-mime, scrollkeeper-update,
update-desktop-database, etc.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Bug reassigned from package `debhelper' to `sgml-base'. Request was from Joey Hess <joeyh@debian.org> to control@bugs.debian.org. (Sun, 04 May 2008 21:21:10 GMT) Full text and rfc822 format available.

Blocking bugs of 477751 added: 85682 Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Tue, 02 Sep 2008 15:45:07 GMT) Full text and rfc822 format available.

Blocking bugs of 477751 removed: 85682 Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Tue, 02 Sep 2008 19:12:07 GMT) Full text and rfc822 format available.

Blocking bugs of 477751 added: 88010 Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Tue, 02 Sep 2008 19:12:09 GMT) Full text and rfc822 format available.

Tags added: lenny-ignore Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Fri, 10 Oct 2008 15:03:02 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Fri, 10 Oct 2008 15:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Leidert <daniel.leidert@wgdd.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Fri, 10 Oct 2008 15:21:06 GMT) Full text and rfc822 format available.

Message #37 received at 477751@bugs.debian.org (full text, mbox):

From: Daniel Leidert <daniel.leidert@wgdd.de>
To: 477751@bugs.debian.org
Cc: 477751-submitter@bugs.debian.org
Subject: dh_installcatalogs: Don't readd catalog on every upgrade to the catalog
Date: Fri, 10 Oct 2008 17:19:27 +0200
Hi,

Just for your information: I will check the design of the current system
for Lenny+1. For Lenny this issue has been tagged with "lenny-ignore".

Regards, Daniel





Message sent on to Jörg Sommer <joerg@alea.gnuu.de>:
Bug#477751. (Fri, 10 Oct 2008 15:21:08 GMT) Full text and rfc822 format available.

Blocking bugs of 477751 removed: 88010 Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Mon, 06 Jul 2009 19:36:06 GMT) Full text and rfc822 format available.

Forcibly Merged 88010 477751. Request was from Daniel Leidert (dale) <daniel.leidert@wgdd.de> to control@bugs.debian.org. (Mon, 06 Jul 2009 19:36:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Fri, 12 Mar 2010 17:21:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefano Zacchiroli <zack@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Fri, 12 Mar 2010 17:21:02 GMT) Full text and rfc822 format available.

Message #49 received at 477751@bugs.debian.org (full text, mbox):

From: Stefano Zacchiroli <zack@debian.org>
To: Daniel Leidert <daniel.leidert@wgdd.de>
Cc: 477751@bugs.debian.org
Subject: Re: Bug#477751: dh_installcatalogs: Don't readd catalog on every upgrade to the catalog
Date: Fri, 12 Mar 2010 18:17:39 +0100
On Fri, Oct 10, 2008 at 05:19:27PM +0200, Daniel Leidert wrote:
> Just for your information: I will check the design of the current system
> for Lenny+1. For Lenny this issue has been tagged with "lenny-ignore".

Hi Daniel, ping on this issue. We're getting close to the Squeeze freeze
and this issue is still pending. Should we postpone the issue to
squeeze+1 (and hence tag this bug as squeeze-ignore) or is there still
time to change the catalog design in the squeeze time frame (TBH, it
seems unlikely to me).

Cheers.

-- 
Stefano Zacchiroli -o- PhD in Computer Science \ PostDoc @ Univ. Paris 7
zack@{upsilon.cc,pps.jussieu.fr,debian.org} -<>- http://upsilon.cc/zack/
Dietro un grande uomo c'è ..|  .  |. Et ne m'en veux pas si je te tutoie
sempre uno zaino ...........| ..: |.... Je dis tu à tous ceux que j'aime




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sat, 02 Oct 2010 14:42:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Philipp Kern <pkern@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sat, 02 Oct 2010 14:42:11 GMT) Full text and rfc822 format available.

Message #54 received at 477751@bugs.debian.org (full text, mbox):

From: Philipp Kern <pkern@debian.org>
To: Stefano Zacchiroli <zack@debian.org>, 477751@bugs.debian.org
Cc: Daniel Leidert <daniel.leidert@wgdd.de>, control@bugs.debian.org
Subject: Re: Bug#477751: dh_installcatalogs: Don't readd catalog on every upgrade to the catalog
Date: Sat, 2 Oct 2010 16:41:19 +0200
[Message part 1 (text/plain, inline)]
tag 477751 + squeeze-ignore
thanks

On Fri, Mar 12, 2010 at 06:17:39PM +0100, Stefano Zacchiroli wrote:
> On Fri, Oct 10, 2008 at 05:19:27PM +0200, Daniel Leidert wrote:
> > Just for your information: I will check the design of the current system
> > for Lenny+1. For Lenny this issue has been tagged with "lenny-ignore".
> Hi Daniel, ping on this issue. We're getting close to the Squeeze freeze
> and this issue is still pending. Should we postpone the issue to
> squeeze+1 (and hence tag this bug as squeeze-ignore) or is there still
> time to change the catalog design in the squeeze time frame (TBH, it
> seems unlikely to me).

Tagging it squeeze-ignore now.

Kind regards,
Philipp Kern 
[signature.asc (application/pgp-signature, inline)]

Added tag(s) squeeze-ignore. Request was from Philipp Kern <pkern@debian.org> to control@bugs.debian.org. (Sat, 02 Oct 2010 14:42:12 GMT) Full text and rfc822 format available.

Added tag(s) patch. Request was from Helmut Grohne <helmut@subdivi.de> to control@bugs.debian.org. (Sun, 04 Dec 2011 12:11:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sun, 04 Dec 2011 13:10:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sun, 04 Dec 2011 13:10:15 GMT) Full text and rfc822 format available.

Message #63 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: 477751@bugs.debian.org, Joey Hess <joeyh@debian.org>
Cc: control@bugs.debian.org
Subject: tackling this bug
Date: Sun, 4 Dec 2011 13:06:06 +0100
[Message part 1 (text/plain, inline)]
tags 477751 +patch
thanks

Hi,

I finally took the opportunity to work on this bug. As Joey Hess pointed
out the first thing to change is update-catalog. On the other hand
surely the debhelper snipped *will* have to change, because it
unconditionally removes a file in /etc. So let us have a look at the
current snippet:

$ cat /usr/share/debhelper/autoscripts/postinst-sgmlcatalog
if [ "$1" = "configure" ]; then
        rm -f #CENTRALCAT#
        for ordcat in #ORDCATS#; do
                update-catalog --quiet --add #CENTRALCAT# ${ordcat}
        done
        update-catalog --quiet --add --super #CENTRALCAT#
fi
$

So there are two places where we do not preserve user changes.

1) Changes to the root catalog. This is due to the update-catalog --quiet --add
--super. It is actually easy to solve, because it is a no-op if the catalog is
already added. Thus it should only be invoked when installing the package. It
should not be invoked when upgrading the package. A simple check on $2 being
empty solves this issue.

2) Changes to the central catalog of the package. This is more tricky
and requires changes to update-catalog. There needs to be some way to
remember what catalogs the user disabled. To achieve this I changed the
behaviour of --remove (see attached debdiff). It will now comment out
catalogs to be removed. Now removing that catalog is no longer a good
thing to do. Instead updatew-catalog needs to do something more clever.
This is where update-catalog --update #CENTRALCAT# #ORDCATS# comes in.
It will walk over the central catalog removing any (disabled or not)
entries not found in the passed #ORDCATS#. It will not touch entries
already present, but add new ones. So this should solve the issue.

The new snipped would look like this:

$ cat postinst-sgmlcatalog.new
if [ "$1" = configure" ]; then
	update-catalog --quiet --update #CENTRALCAT# #ORDCATS#
	if [ -z "$2" ]; then
		update-catalog --quiet --add --super #CENTRALCAT#
	fi
fi
$

So what are your thoughts on this?

Helmut
[sgml-base.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sun, 04 Dec 2011 21:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sun, 04 Dec 2011 21:27:03 GMT) Full text and rfc822 format available.

Message #68 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org
Subject: Re: tackling this bug
Date: Sun, 4 Dec 2011 17:25:42 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> So what are your thoughts on this?

I haven't considered all the implications... Will the new sgml-base
work ok with the old postinst? With mixtures of the new and old
postinsts?

I'm happy moving ahead with the debhelper changes as soon as sgml-base
is in unstable.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sun, 04 Dec 2011 23:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sun, 04 Dec 2011 23:03:06 GMT) Full text and rfc822 format available.

Message #73 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org
Subject: Re: tackling this bug
Date: Sun, 4 Dec 2011 23:59:55 +0100
Hi Joey,

thanks for your quick answer.

On Sun, Dec 04, 2011 at 05:25:42PM -0400, Joey Hess wrote:
> I haven't considered all the implications... Will the new sgml-base
> work ok with the old postinst? With mixtures of the new and old
> postinsts?

Good question! Let's look at them individually. The old postinst just
uses --add which is idempotent (old and new). So this should all work
out. The old postrm just does rm and the old prerm does --remove on the
root catalog. This should work as well (even though it now leaves a
comment). The prerm however needs updating as well, as it should no
longer --remove on upgrade (as we can no longer --add on upgrade).

> I'm happy moving ahead with the debhelper changes as soon as sgml-base
> is in unstable.

Good. This would also necessitate a versioned dependency on sgml-base.

Do you want a diff for debhelper?

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sun, 04 Dec 2011 23:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Leidert <daniel.leidert@wgdd.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sun, 04 Dec 2011 23:15:03 GMT) Full text and rfc822 format available.

Message #78 received at 477751@bugs.debian.org (full text, mbox):

From: Daniel Leidert <daniel.leidert@wgdd.de>
To: 477751@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>, Helmut Grohne <helmut@subdivi.de>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 05 Dec 2011 00:05:26 +0100
Am Sonntag, den 04.12.2011, 13:06 +0100 schrieb Helmut Grohne:

[..]
> So what are your thoughts on this?

My thoughts on this are pretty easy. There are IMO three mechanisms to
use:

(1) Register the catalog, if it exists (and unregister any registered
catalog, if it doesn't exist anymore). So users can remove the package
catalog file.

(2) Register the catalog only during installation, but not during
upgrade. Usually we only add a catalog reference to the super
catalog.

(3) Catalog files should be written at build time not during
installation. Instead of creating /etc/sgml/package.cat during
installation, this should be created during package build. So the user
can edit /etc/sgml/package.cat and /etc/sgml/catalog and we preserve
these changes.

If the user now changes /etc/sgml/package.cat and we need to ship an
updated file, he should usually be asked, if he wishes to update the
file during installation.

IMO we don't need to check, what has been "disabled" or not. Or does
this have any advantages IYO?

Regards, Daniel






Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Mon, 05 Dec 2011 15:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Mon, 05 Dec 2011 15:30:03 GMT) Full text and rfc822 format available.

Message #83 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Daniel Leidert <daniel.leidert@wgdd.de>
Cc: Joey Hess <joeyh@debian.org>, 477751@bugs.debian.org
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 5 Dec 2011 16:18:16 +0100
Hi Daniel,

On Mon, Dec 05, 2011 at 12:05:26AM +0100, Daniel Leidert wrote:
> My thoughts on this are pretty easy. There are IMO three mechanisms to
> use:
> 
> (1) Register the catalog, if it exists (and unregister any registered
> catalog, if it doesn't exist anymore). So users can remove the package
> catalog file.
> 
> (2) Register the catalog only during installation, but not during
> upgrade. Usually we only add a catalog reference to the super
> catalog.

This is what I proposed. It can be done today with a simple change to
debhelper and no changes to sgml-base.

> (3) Catalog files should be written at build time not during
> installation. Instead of creating /etc/sgml/package.cat during
> installation, this should be created during package build. So the user
> can edit /etc/sgml/package.cat and /etc/sgml/catalog and we preserve
> these changes.

Initially I thought about this as well. The problem with this is that
currently /etc/sgml/package.cat is not owned by any package. So by
switching a package to this model, each installation would prompt the
user for those files.

> If the user now changes /etc/sgml/package.cat and we need to ship an
> updated file, he should usually be asked, if he wishes to update the
> file during installation.
>
> IMO we don't need to check, what has been "disabled" or not. Or does
> this have any advantages IYO?

It works without asking the user questions during upgrade. This applies
both to a transitioning period and to the long term when a package.cat
changes.

I don't really care whether the user is asked on package upgrades after
he changes those files. But installations where no user changed those
files should definitely not ask the user.

So I propose that either you come up with a method to cleanly take over
ownership of those configuration files or we use my approach. In any
case this bug should be fixed some way or another.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Mon, 05 Dec 2011 16:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Mon, 05 Dec 2011 16:24:03 GMT) Full text and rfc822 format available.

Message #88 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org
Subject: Re: tackling this bug
Date: Mon, 5 Dec 2011 12:20:25 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> Good. This would also necessitate a versioned dependency on sgml-base.

Yes, easy since it already uses misc:Depends.

> Do you want a diff for debhelper?

Would be appreciated.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Mon, 12 Dec 2011 13:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Mon, 12 Dec 2011 13:54:04 GMT) Full text and rfc822 format available.

Message #93 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Daniel Leidert <daniel.leidert@wgdd.de>
Cc: 477751@bugs.debian.org, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 12 Dec 2011 14:51:49 +0100
[Message part 1 (text/plain, inline)]
Hi Daniel and Joey,

I took some more time to look at Daniel's proposal and managed to come
up with an implementation which consists of one debdiff to only
debhelper (no sgml-base changes).

On Mon, Dec 05, 2011 at 12:05:26AM +0100, Daniel Leidert wrote:
> (1) Register the catalog, if it exists (and unregister any registered
> catalog, if it doesn't exist anymore). So users can remove the package
> catalog file.
> 
> (2) Register the catalog only during installation, but not during
> upgrade. Usually we only add a catalog reference to the super
> catalog.
> 
> (3) Catalog files should be written at build time not during
> installation. Instead of creating /etc/sgml/package.cat during
> installation, this should be created during package build. So the user
> can edit /etc/sgml/package.cat and /etc/sgml/catalog and we preserve
> these changes.
> 
> If the user now changes /etc/sgml/package.cat and we need to ship an
> updated file, he should usually be asked, if he wishes to update the
> file during installation.

I implemented the above description. The details are:

 * prerm will no longer remove the package catalog from the root catalog
   during upgrade.
 * postrm will only remove the .old file on purge (dpkg remove the
   conffile /etc/sgml/$package.cat).
 * postinst will no longer regenerate /etc/sgml/$package.cat and only
   add the package catalog to the root catalog during installation (as
   it is no longer removed during upgrade).
 * dh_installcatalogs will create a /etc/sgml/$package.cat containing
   the same contents (without the comment header).
 * preinst will do the tricky transition part. If it is called during an
   upgrade and /etc/sgml/$package.cat is not owned by any package (this
   is currently the case), then it fixes up the installation. The old
   prerm will have the package catalog removed from the root catalog, so
   it is readded here. The old postinst would recreate
   /etc/sgml/$package.cat. This file is removed during preinst. The
   advantage of this approach is that the conffile can be installed
   without asking the user. The disadvantage of this approach is that
   we are overwriting user changes one more time.

There is a debhelper.debdiff attached which implements the above
description. I have rebuild xml-core using this patched debhelper and
tried to upgrade and reinstall xml-core. However downgrading xml-core
and upgrading it again results in a broken installation. Even when
downgrading a package a conffile stays to be a conffile, so the preinst
hook is only executed during the first upgrade. After the second upgrade
the /etc/sgml/$package.cat is left untouched (being a conffile) and
missing from /etc/sgml/catalog.

What do you think about this approach?

Helmut
[debhelper.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sat, 07 Jan 2012 17:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sat, 07 Jan 2012 17:06:03 GMT) Full text and rfc822 format available.

Message #98 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>, Daniel Leidert <daniel.leidert@wgdd.de>, 477751@bugs.debian.org
Subject: Re: Bug#477751: tackling this bug
Date: Sat, 7 Jan 2012 13:01:56 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
>  * preinst will do the tricky transition part. If it is called during an
>    upgrade and /etc/sgml/$package.cat is not owned by any package (this
>    is currently the case), then it fixes up the installation. The old
>    prerm will have the package catalog removed from the root catalog, so
>    it is readded here. The old postinst would recreate
>    /etc/sgml/$package.cat. This file is removed during preinst. The
>    advantage of this approach is that the conffile can be installed
>    without asking the user. The disadvantage of this approach is that
>    we are overwriting user changes one more time.

I don't think it's appropriate to put "tricky transition" code into
debhelper autoscripts, from where it is exploded out to lots of
packages. If it's tricky, it's going to break, and it needs to be in a
centralized location so the breakage can be fixed with one upload.

Also, it's quite likely that other packages also use update-catalog,
without using dh_installcatalogs. So this should be fixed in
update-catalog.

>  There is a debhelper.debdiff attached which implements the above
> description. I have rebuild xml-core using this patched debhelper and
> tried to upgrade and reinstall xml-core. However downgrading xml-core
> and upgrading it again results in a broken installation. Even when
> downgrading a package a conffile stays to be a conffile, so the preinst
> hook is only executed during the first upgrade. After the second upgrade
> the /etc/sgml/$package.cat is left untouched (being a conffile) and
> missing from /etc/sgml/catalog.

It's not clear to me if this is a serious problem with this approach or
not. I will let the maintainer of update-catalog deside when
implementing their solution.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sat, 07 Jan 2012 18:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sat, 07 Jan 2012 18:39:03 GMT) Full text and rfc822 format available.

Message #103 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: Daniel Leidert <daniel.leidert@wgdd.de>, 477751@bugs.debian.org
Subject: Re: Bug#477751: tackling this bug
Date: Sat, 7 Jan 2012 19:35:16 +0100
Hi Joey,

thanks for your response.

On Sat, Jan 07, 2012 at 01:01:56PM -0400, Joey Hess wrote:
> Helmut Grohne wrote:
> >  * preinst will do the tricky transition part. If it is called during an
> >    upgrade and /etc/sgml/$package.cat is not owned by any package (this
> >    is currently the case), then it fixes up the installation. The old
> >    prerm will have the package catalog removed from the root catalog, so
> >    it is readded here. The old postinst would recreate
> >    /etc/sgml/$package.cat. This file is removed during preinst. The
> >    advantage of this approach is that the conffile can be installed
> >    without asking the user. The disadvantage of this approach is that
> >    we are overwriting user changes one more time.
> 
> I don't think it's appropriate to put "tricky transition" code into
> debhelper autoscripts, from where it is exploded out to lots of
> packages. If it's tricky, it's going to break, and it needs to be in a
> centralized location so the breakage can be fixed with one upload.

I agree that the complexity should not reside in debhelper templates.
However that is already the case. The entire code that is responsible
for #88010 already is contained in debhelper. It is debhelper's prerm
that removes the package catalog from the root catalog. And it is
debhelper's postinst that removes the package catalog file. Those are
two removals shipped in current debhelper and they are causing the harm.
One of those removals is done using /bin/rm (out of scope of sgml-base)
and the other removal is a call to update-catalog --quiet --remove
--super /etc/sgml/$package.cat. Turning this into a no-op is error prone
on its own as it might legitimately be invoked that way from a user.

Please observe how my debdiff reduces this complexity. By generating the
package catalog at build time the code that modifies the package catalog
at installation time is removed altogether. All that remains are two
calls to update-catalog in postinst and prerm to modify the root
catalog. The preinst and postrm contents are only needed for the
transition period to fix old stuff.

> Also, it's quite likely that other packages also use update-catalog,
> without using dh_installcatalogs. So this should be fixed in
> update-catalog.

Unless those other packages use the same snippets as debhelper they are
not affected. If they do, those packages need to be fixed separately,
but this issue cannot be solved by a change to update-catalog.

> >  There is a debhelper.debdiff attached which implements the above
> > description. I have rebuild xml-core using this patched debhelper and
> > tried to upgrade and reinstall xml-core. However downgrading xml-core
> > and upgrading it again results in a broken installation. Even when
> > downgrading a package a conffile stays to be a conffile, so the preinst
> > hook is only executed during the first upgrade. After the second upgrade
> > the /etc/sgml/$package.cat is left untouched (being a conffile) and
> > missing from /etc/sgml/catalog.
> 
> It's not clear to me if this is a serious problem with this approach or
> not. I will let the maintainer of update-catalog deside when
> implementing their solution.

If you can come up with a better approach to detect an old debhelper
template, I can adapt the patch. For instance I could craft a regular
expression for grepping $(dpkg-query --control-path $package postinst).

I would expect a number of packages to break when you try to downgrade
them. Also note that downgrading packages is not officially supported
(especially when downgrading towards a broken package).

As far as I can see sgml-base is unmaintained. It received its last
maintainer upload in 2004, so it seems pointless to wait for the
maintainer.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sat, 07 Jan 2012 18:57:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sat, 07 Jan 2012 18:57:07 GMT) Full text and rfc822 format available.

Message #108 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: Daniel Leidert <daniel.leidert@wgdd.de>, 477751@bugs.debian.org
Subject: Re: Bug#477751: tackling this bug
Date: Sat, 7 Jan 2012 14:53:46 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> I agree that the complexity should not reside in debhelper templates.
> However that is already the case. The entire code that is responsible
> for #88010 already is contained in debhelper. It is debhelper's prerm
> that removes the package catalog from the root catalog. And it is
> debhelper's postinst that removes the package catalog file. Those are
> two removals shipped in current debhelper and they are causing the harm.
> One of those removals is done using /bin/rm (out of scope of sgml-base)
> and the other removal is a call to update-catalog --quiet --remove
> --super /etc/sgml/$package.cat. Turning this into a no-op is error prone
> on its own as it might legitimately be invoked that way from a user.

I'm not suggesting that the existing code, as currently present in
package maintainer scripts everywhere, should somehow implement this
transition.

But update-catalog can get new switches that handle the transition, and
debhelper can update the code to use them.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Sat, 07 Jan 2012 21:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Sat, 07 Jan 2012 21:27:06 GMT) Full text and rfc822 format available.

Message #113 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: Daniel Leidert <daniel.leidert@wgdd.de>, 477751@bugs.debian.org
Subject: Re: Bug#477751: tackling this bug
Date: Sat, 7 Jan 2012 22:25:18 +0100
Hi Joey,

On Sat, Jan 07, 2012 at 02:53:46PM -0400, Joey Hess wrote:
> But update-catalog can get new switches that handle the transition, and
> debhelper can update the code to use them.

Ok. Let's evaulate what could be changed about update-catalog.
1) package catalog.
   As per Daniel's request the package catalogs are now created at build
   time, so update-catalog no longer touches them. The only place we
   still touch the package catalog is to remove it (being an unowned
   file in /etc) to transition to a proper configfile. So we would add
   some update-catalog --transition-catalog to the debhelper preinst. It
   would have do the magic to detect whether this transition is actually
   necessary.
2) root catalog.
   The package catalog is currently removed and readded to the root
   catalog during every upgrade. This is to change, but the next upgrade
   will still do the removal. So the --transition-catalog would do this
   as well.

This --transition-catalog would do harm to the system when invoked by an
administrator since it relies on the broken behaviour of debhelper's
prerm and the creation of the conffile by the package upgrade.

Essentially the transitional code that I put into preinst would be moved
to update-catalog. I honestly do not see the value in this. In fact it
the complexity is even larger since we now have to depend on a newer
version of sgml-base and if we really need to apply further fixes we
need to change two packages now. Not mentioning the combinatorial
explosion of version combinations (of debhelper and sgml-base). Another
argument against this move is that it makes removing the transitional
code much harder.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org, Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>:
Bug#477751; Package sgml-base. (Thu, 12 Jan 2012 09:45:24 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>. (Thu, 12 Jan 2012 09:45:25 GMT) Full text and rfc822 format available.

Message #118 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: 477751@bugs.debian.org, control@bugs.debian.org
Subject: reassigning #477751 to debhelper
Date: Thu, 12 Jan 2012 10:41:32 +0100
reassign 477751 debhelper
affects 477751 sgml-base
thanks

Reasons:
 * The debhelper templates are mainly responsible for this issue.
 * Any solution that fixes this issue requires changes to debhelper.
 * There exists a solution (attached to this bug log), that solves the
   issue by just patching debhelper. (No upload of sgml-base is
   required.)

Thus it seems reasonable that this bug belongs to debhelper.

Helmut




Bug reassigned from package 'sgml-base' to 'debhelper'. Request was from Helmut Grohne <helmut@subdivi.de> to control@bugs.debian.org. (Thu, 12 Jan 2012 09:45:29 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions 1.07. Request was from Helmut Grohne <helmut@subdivi.de> to control@bugs.debian.org. (Thu, 12 Jan 2012 09:45:30 GMT) Full text and rfc822 format available.

Added indication that 477751 affects sgml-base Request was from Helmut Grohne <helmut@subdivi.de> to control@bugs.debian.org. (Thu, 12 Jan 2012 09:45:30 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Sun, 15 Apr 2012 17:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Sun, 15 Apr 2012 17:21:06 GMT) Full text and rfc822 format available.

Message #129 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: Daniel Leidert <daniel.leidert@wgdd.de>, 477751@bugs.debian.org
Subject: [ping] Re: Bug#477751: tackling this bug
Date: Sun, 15 Apr 2012 19:18:37 +0200
Hi Joey,

There is still no progress on this release critical issue. Given the
number of affected packages that will need a rebuild and the freeze in
June, I ask for action. Can you comment on my reasons against the
proposed change to sgml-base or come up with a solution yourself?

These were my points.

On Sat, Jan 07, 2012 at 10:25:17PM +0100, Helmut Grohne wrote:
> On Sat, Jan 07, 2012 at 02:53:46PM -0400, Joey Hess wrote:
> > But update-catalog can get new switches that handle the transition, and
> > debhelper can update the code to use them.
> 
> Ok. Let's evaulate what could be changed about update-catalog.
> 1) package catalog.
>    As per Daniel's request the package catalogs are now created at build
>    time, so update-catalog no longer touches them. The only place we
>    still touch the package catalog is to remove it (being an unowned
>    file in /etc) to transition to a proper configfile. So we would add
>    some update-catalog --transition-catalog to the debhelper preinst. It
>    would have do the magic to detect whether this transition is actually
>    necessary.
> 2) root catalog.
>    The package catalog is currently removed and readded to the root
>    catalog during every upgrade. This is to change, but the next upgrade
>    will still do the removal. So the --transition-catalog would do this
>    as well.
> 
> This --transition-catalog would do harm to the system when invoked by an
> administrator since it relies on the broken behaviour of debhelper's
> prerm and the creation of the conffile by the package upgrade.
> 
> Essentially the transitional code that I put into preinst would be moved
> to update-catalog. I honestly do not see the value in this. In fact it
> the complexity is even larger since we now have to depend on a newer
> version of sgml-base and if we really need to apply further fixes we
> need to change two packages now. Not mentioning the combinatorial
> explosion of version combinations (of debhelper and sgml-base). Another
> argument against this move is that it makes removing the transitional
> code much harder.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Sun, 15 Apr 2012 18:51:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Sun, 15 Apr 2012 18:51:09 GMT) Full text and rfc822 format available.

Message #134 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>, 477751@bugs.debian.org
Cc: Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: [ping] Re: Bug#477751: tackling this bug
Date: Sun, 15 Apr 2012 14:47:03 -0400
Helmut Grohne wrote:
> These were my points.
> 
> On Sat, Jan 07, 2012 at 10:25:17PM +0100, Helmut Grohne wrote:
> > On Sat, Jan 07, 2012 at 02:53:46PM -0400, Joey Hess wrote:
> > > But update-catalog can get new switches that handle the transition, and
> > > debhelper can update the code to use them.
> > 
> > Ok. Let's evaulate what could be changed about update-catalog.
> > 1) package catalog.
> >    As per Daniel's request the package catalogs are now created at build
> >    time, so update-catalog no longer touches them. The only place we
> >    still touch the package catalog is to remove it (being an unowned
> >    file in /etc) to transition to a proper configfile. So we would add
> >    some update-catalog --transition-catalog to the debhelper preinst. It
> >    would have do the magic to detect whether this transition is actually
> >    necessary.

> > This --transition-catalog would do harm to the system when invoked by an
> > administrator since it relies on the broken behaviour of debhelper's
> > prerm and the creation of the conffile by the package upgrade.

Your patch already has the preinst calling update-catalog. AFAICS, 
update-catalog could check with dpkg-query if the file is not owned
by a package, and not remove it unless this was the case, and it was
called with --transition. 

In the unlikely event that the admin called it, it would detect that
the file was a conffile and not delete it.

> > Essentially the transitional code that I put into preinst would be moved
> > to update-catalog. I honestly do not see the value in this. In fact it
> > the complexity is even larger since we now have to depend on a newer
> > version of sgml-base

I do not see any complexity in a versioned dependency;
dh_installcatalogs already adds one.

> > and if we really need to apply further fixes we
> > need to change two packages now.

No, you just change sgml-base in a manner consistent with its new interface.
debhelper does not enter this highly hypothetical scenario.

> > Not mentioning the combinatorial
> > explosion of version combinations (of debhelper and sgml-base)

AFAICS the "explosion" results in 4 combinations.

> > Another
> > argument against this move is that it makes removing the transitional
> > code much harder.

Well, it's what, 3 lines? The difference is that it's 3 lines in one
place.

-- 
see shy jo




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Sun, 15 Apr 2012 19:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Sun, 15 Apr 2012 19:57:02 GMT) Full text and rfc822 format available.

Message #139 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Sun, 15 Apr 2012 21:52:47 +0200
Hi Joey,

Thanks for your quick response after the ping.

On Sun, Apr 15, 2012 at 02:47:03PM -0400, Joey Hess wrote:
> Your patch already has the preinst calling update-catalog. AFAICS, 
> update-catalog could check with dpkg-query if the file is not owned
> by a package, and not remove it unless this was the case, and it was
> called with --transition. 

Agreed.

> In the unlikely event that the admin called it, it would detect that
> the file was a conffile and not delete it.

An admin could call update-catalog --transition for a package that was
not rebuilt with the newer debhelper. In that case harm would still
happen. Do you have an idea about how to prevent this?

> I do not see any complexity in a versioned dependency;
> dh_installcatalogs already adds one.

It must be a Pre-Depends, since we are using it in preinst. So I could
argue that it is even too complex for you to spot on the first look.

> > > and if we really need to apply further fixes we
> > > need to change two packages now.
> 
> No, you just change sgml-base in a manner consistent with its new interface.
> debhelper does not enter this highly hypothetical scenario.

I agree on your reasoning to keep the transition code at a single place.
If things really go wrong though, I would assume that just changing the
preinst hook is not enough. In that case we really need to touch
debhelper as well.

> > > Not mentioning the combinatorial
> > > explosion of version combinations (of debhelper and sgml-base)
> 
> AFAICS the "explosion" results in 4 combinations.

If you were not planning on further fixes, there would be no need to
move the transitional code to sgml-base, because it would just work.
Assuming that we need to release another sgml-base and debhelper version
we now have at least 9 combinations.

The actual explosion resides in the relationships. As pointed out above,
we already need Pre-Depend. The number of possible relationships you can
declare really explodes.

> > > Another
> > > argument against this move is that it makes removing the transitional
> > > code much harder.
> 
> Well, it's what, 3 lines? The difference is that it's 3 lines in one
> place.

Almost. You need to remove both the caller and the callee. Even though
concur with your line count, this is two places.

If we can sort out the issue about the admin, I can change the patch to
move the transitional code to sgml-base.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Tue, 17 Apr 2012 13:12:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Tue, 17 Apr 2012 13:12:03 GMT) Full text and rfc822 format available.

Message #144 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Tue, 17 Apr 2012 09:08:30 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> > In the unlikely event that the admin called it, it would detect that
> > the file was a conffile and not delete it.
> 
> An admin could call update-catalog --transition for a package that was
> not rebuilt with the newer debhelper. In that case harm would still
> happen. Do you have an idea about how to prevent this?

Since this is deleting possibly modified config files on upgrade anyway,
this doesn't seem worth worrying about.

> > I do not see any complexity in a versioned dependency;
> > dh_installcatalogs already adds one.
> 
> It must be a Pre-Depends, since we are using it in preinst.

Ok, that's annoying as each package would need misc:PreDepends added.

In that case, maybe this should be left in debhelper. I am pretty
uncomfortable with it though, especially since it does delete config
files.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Tue, 17 Apr 2012 16:48:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Tue, 17 Apr 2012 16:48:02 GMT) Full text and rfc822 format available.

Message #149 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Tue, 17 Apr 2012 18:44:17 +0200
On Tue, Apr 17, 2012 at 09:08:30AM -0400, Joey Hess wrote:
> Helmut Grohne wrote:
> > An admin could call update-catalog --transition for a package that was
> > not rebuilt with the newer debhelper. In that case harm would still
> > happen. Do you have an idea about how to prevent this?
> 
> Since this is deleting possibly modified config files on upgrade anyway,
> this doesn't seem worth worrying about.

Thinking about it we could check the state of the package being
transitioned. If an admin calls --transition that would most likely be
"ii". If preinst calls it, I guess it would be "iF" or at least not
"ii".

> Ok, that's annoying as each package would need misc:PreDepends added.
> 
> In that case, maybe this should be left in debhelper. I am pretty
> uncomfortable with it though, especially since it does delete config
> files.

So we seem to agree that both solutions (present vs. adding --transition
to sgml-base) are doable and both have their own problems. Are you still
interested in pushing the transitional code to sgml-base? Your arguments
have convinced me that it could work. I have not yet updated the patch
to do that, so please tell me whether you want that change (at least for
evaluation).

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Thu, 26 Apr 2012 18:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Thu, 26 Apr 2012 18:00:03 GMT) Full text and rfc822 format available.

Message #154 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Thu, 26 Apr 2012 13:57:33 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> So we seem to agree that both solutions (present vs. adding --transition
> to sgml-base) are doable and both have their own problems. Are you still
> interested in pushing the transitional code to sgml-base? Your arguments
> have convinced me that it could work. I have not yet updated the patch
> to do that, so please tell me whether you want that change (at least for
> evaluation).

While I'm leaning toward just putting the code in debhelper,
I am worried about another issue in the patch. It makes
update-catalog be called only on new install, not upgrade ([-z "$2"]).
But then, if a catalog is added to an existing package,
update-catalog will not be run. There is a new preinst that
runs update-catalog on upgrade, but only during the transition
to conffiles, so it does not close this hole.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Thu, 26 Apr 2012 21:09:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Thu, 26 Apr 2012 21:09:17 GMT) Full text and rfc822 format available.

Message #159 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Thu, 26 Apr 2012 23:06:47 +0200
On Thu, Apr 26, 2012 at 01:57:33PM -0400, Joey Hess wrote:
> While I'm leaning toward just putting the code in debhelper,
> I am worried about another issue in the patch. It makes
> update-catalog be called only on new install, not upgrade ([-z "$2"]).
> But then, if a catalog is added to an existing package,
> update-catalog will not be run. There is a new preinst that
> runs update-catalog on upgrade, but only during the transition
> to conffiles, so it does not close this hole.

Thanks for looking at it this close. This issue definitely needs to be
addressed.

It gets even worse. Consider the case where a maintainer removes a
catalog from an existing package and stops calling dh_installcatalogs.
Then the root catalog would contain a dangling reference and there
really is no way to fix this anymore, because our code is never invoked
again. This probably is precisely the reason for why we currently remove
and add the catalog. To fix this, we will have to keep removing the
package catalog from the root catalog in prerm, but remember that we did
it. In the postinst we will have to add it again, iff we removed it
before. The big question for me would be: How to transfer this state
from prerm to postinst?

Options would be:
1) Some state file in /etc. The apache2 upgrade to experimental takes
   this approach for instance. (Thanks to Arno Töll for pointing out.)
2) Some state file in /var/run. See sysv-rc for an example. A downside
   is that if our upgrade gets interrupted and the system is rebooted,
   our state file is gone.
3) Some state file in /var/lib. Seems ugly.
3) Abuse some debconf key for this.
4) Something else?

Any opinion on this?

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Thu, 26 Apr 2012 22:21:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Thu, 26 Apr 2012 22:21:03 GMT) Full text and rfc822 format available.

Message #164 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Thu, 26 Apr 2012 18:18:40 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> It gets even worse. Consider the case where a maintainer removes a
> catalog from an existing package and stops calling dh_installcatalogs.
> Then the root catalog would contain a dangling reference and there
> really is no way to fix this anymore, because our code is never invoked
> again. This probably is precisely the reason for why we currently remove
> and add the catalog. To fix this, we will have to keep removing the
> package catalog from the root catalog in prerm, but remember that we did
> it. In the postinst we will have to add it again, iff we removed it
> before. The big question for me would be: How to transfer this state
> from prerm to postinst?

This is why I originally recommended that the registration process be
converted to use triggers. A file fill of catalogs, and a root catalog
file automatically generated from them (which need not be a config file
in /etc) is a much cleaner approach.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Thu, 26 Apr 2012 23:39:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Thu, 26 Apr 2012 23:39:06 GMT) Full text and rfc822 format available.

Message #169 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Thu, 26 Apr 2012 19:27:17 -0400
[Message part 1 (text/plain, inline)]
Joey Hess wrote:
> This is why I originally recommended that the registration process be
> converted to use triggers. A file fill of catalogs, and a root catalog
                               ^^^^^^^^^ directory full
> file automatically generated from them (which need not be a config file
> in /etc) is a much cleaner approach.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Fri, 27 Apr 2012 08:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Fri, 27 Apr 2012 08:15:04 GMT) Full text and rfc822 format available.

Message #174 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Fri, 27 Apr 2012 10:13:14 +0200
On Thu, Apr 26, 2012 at 06:18:40PM -0400, Joey Hess wrote:
> This is why I originally recommended that the registration process be
> converted to use triggers. A [directory full] of catalogs, and a root catalog
> file automatically generated from them (which need not be a config file
> in /etc) is a much cleaner approach.

This change would be fairly intrusive, but it clearly has its
advantages. update-catalog would be updated to turn any calls containing
--super into no-ops. These configuration options are somewhat "burnt" by
the current prerm and postinst invocations and can no longer be used by
an administrator in a sane way. /etc/sgml/catalog would be regenerated
using a new update-catalog --update-super. (I don't think moving the
file elsewhere is feasible.) It would unconditionally overwrite
/etc/sgml/catalog to include /etc/sgml/*.cat. The trigger interest would
be declared in sgml-base. No trigger activation is necessary. The
generated /etc/sgml/catalog would explain that to remove a catalog an
administrator should call update-catalog --disable $package. This would
mv /etc/sgml/$package.cat{,.disabled} and --update-super. Similarly
--enable $package would revert this change. These file moves persist
during upgrades, because removed conffiles are not readded. Does this
method have any obvious problems? I can write a patch.

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Fri, 27 Apr 2012 14:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Fri, 27 Apr 2012 14:57:06 GMT) Full text and rfc822 format available.

Message #179 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Fri, 27 Apr 2012 10:54:01 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> On Thu, Apr 26, 2012 at 06:18:40PM -0400, Joey Hess wrote:
> > This is why I originally recommended that the registration process be
> > converted to use triggers. A [directory full] of catalogs, and a root catalog
> > file automatically generated from them (which need not be a config file
> > in /etc) is a much cleaner approach.
> 
> This change would be fairly intrusive, but it clearly has its
> advantages. update-catalog would be updated to turn any calls containing
> --super into no-ops. These configuration options are somewhat "burnt" by
> the current prerm and postinst invocations and can no longer be used by
> an administrator in a sane way. /etc/sgml/catalog would be regenerated
> using a new update-catalog --update-super. (I don't think moving the
> file elsewhere is feasible.) 

It certianly seems feasible to convert it to a symlink into /var.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Mon, 30 Apr 2012 15:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 30 Apr 2012 15:57:03 GMT) Full text and rfc822 format available.

Message #184 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 30 Apr 2012 17:52:35 +0200
[Message part 1 (text/plain, inline)]
On Fri, Apr 27, 2012 at 10:54:01AM -0400, Joey Hess wrote:
> It certianly seems feasible to convert it to a symlink into /var.

I worked out the sgml-base part of the patch. It will turn the super
catalog into a symbolic link from /etc/sgml/catalog to
/var/lib/sgml-base/supercatalog and update the latter file using
triggers. The loosing of user configuration will persist in all detail
until packages are built with a fixed version of debhelper. I verified
that upgrading to my sgml-base nmu and reinstalling docutils-common (a
caller of update-catalog) works as expected.

On the debhelper side it should be enough to remove all remaining calls
to update-catalog and introduce a dependency on the changed sgml-base. I
did not test this thus far.

Can you comment on the approach taken in the sgml-base.debdiff?

Helmut
[sgml-base.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Mon, 30 Apr 2012 16:27:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Mon, 30 Apr 2012 16:27:02 GMT) Full text and rfc822 format available.

Message #189 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>, 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 30 Apr 2012 12:24:52 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> I worked out the sgml-base part of the patch. It will turn the super
> catalog into a symbolic link from /etc/sgml/catalog to
> /var/lib/sgml-base/supercatalog and update the latter file using
> triggers. The loosing of user configuration will persist in all detail
> until packages are built with a fixed version of debhelper. I verified
> that upgrading to my sgml-base nmu and reinstalling docutils-common (a
> caller of update-catalog) works as expected.
> 
> On the debhelper side it should be enough to remove all remaining calls
> to update-catalog and introduce a dependency on the changed sgml-base. I
> did not test this thus far.

Won't dh_installcatalogs also need to be modified to stop deleting the
package's central catalog file on upgrade? Or does this do away with
the "central catalog" thing and just use the super catalog?

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Mon, 30 Apr 2012 16:40:00 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 30 Apr 2012 16:40:00 GMT) Full text and rfc822 format available.

Message #194 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 30 Apr 2012 18:38:36 +0200
On Mon, Apr 30, 2012 at 12:24:52PM -0400, Joey Hess wrote:
> Helmut Grohne wrote:
> > On the debhelper side it should be enough to remove all remaining calls
> > to update-catalog and introduce a dependency on the changed sgml-base. I
> > did not test this thus far.
> 
> Won't dh_installcatalogs also need to be modified to stop deleting the
> package's central catalog file on upgrade? Or does this do away with
> the "central catalog" thing and just use the super catalog?

There are two places where the central catalog is deleted. I am not
sure which of them you are talking about:
1) During postinst the old snippet removes and recreates the central
   catalog. This behaviour is removed by my debhelper.debdiff.
2) The transitional code I added removes the central catalog in preinst
   if the central catalog is not a conffile. This call could be
   disabled. That would cause a question about a supposedly user
   modified configuration file for every single central catalog that is
   shipped with a package being rebuild with an updated debhelper. I
   deemed this question unacceptable, because it would hit every
   installation (even those who never actively touched those files). By
   removing the file in preinst, dpkg will put the file back during
   unpack and everything is fine (except one more loss of user
   configuration).

So we still have central catalogs, but they are proper conffiles now.

Does this answer your question?

Helmut




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Mon, 30 Apr 2012 17:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Mon, 30 Apr 2012 17:12:03 GMT) Full text and rfc822 format available.

Message #199 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>, 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 30 Apr 2012 13:09:42 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> On Mon, Apr 30, 2012 at 12:24:52PM -0400, Joey Hess wrote:
> > Helmut Grohne wrote:
> > > On the debhelper side it should be enough to remove all remaining calls
> > > to update-catalog and introduce a dependency on the changed sgml-base. I
> > > did not test this thus far.

> There are two places where the central catalog is deleted. I am not
> sure which of them you are talking about:
> 1) During postinst the old snippet removes and recreates the central
>    catalog. This behaviour is removed by my debhelper.debdiff.

Ok, so you still want that applied. Was not clear.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Wed, 09 May 2012 15:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Wed, 09 May 2012 15:27:07 GMT) Full text and rfc822 format available.

Message #204 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>, 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>
Cc: debian-xml-sgml-pkgs@lists.alioth.debian.org, Ardo van Rangelrooij <ardo@debian.org>
Subject: Re: Bug#477751: tackling this bug
Date: Wed, 9 May 2012 17:24:52 +0200
[Message part 1 (text/plain, inline)]
On Mon, Apr 30, 2012 at 05:52:35PM +0200, Helmut Grohne wrote:
> On the debhelper side it should be enough to remove all remaining calls
> to update-catalog and introduce a dependency on the changed sgml-base. I
> did not test this thus far.

I worked out the remaining bits and tested them. For convenience the
very same sgml-base.debdiff as in the previous mail is attached. In
addition a debhelper.debdiff fixing this issue is attached. I verified
the following things (in pbuilder):

1) Building sgml-base NMU.
2) Building debhelper NMU.
3) Installing sgml-base NMU.
4) Upgrading sgml-base from sid to NMU.
5) Upgrading debhelper from sid to NMU.
6) Building python-docutils with debhelper NMU.
7) Upgrading docutils-common to binNMU.
8) Purging docutils-common binNMU.
9) Installing docutils-common binNMU.

I did not observe any problems like obvious failures or even conffile
questions. I looked at /etc/sgml/catalog and
/etc/sgml/docutils-common.cat after each step and verified that the
contents are sensible.

Note that downgrading sgml-base leaves artifacts.

Also note that if the debhelper.debdiff gets applied before the
sgml-base.debdiff gets applied, packages built with the updated
debhelper will be uninstallable.

I ask for feedback on this combination of patches. Since the bug is
assigned to debhelper now, I explicitly pull in the sgml-base
maintainers (who seem to be MIA).

Helmut
[sgml-base.debdiff (text/plain, attachment)]
[debhelper.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#477751; Package debhelper. (Wed, 09 May 2012 15:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. (Wed, 09 May 2012 15:51:03 GMT) Full text and rfc822 format available.

Message #209 received at 477751@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Helmut Grohne <helmut@subdivi.de>, 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>, debian-xml-sgml-pkgs@lists.alioth.debian.org, Ardo van Rangelrooij <ardo@debian.org>
Subject: Re: Bug#477751: tackling this bug
Date: Wed, 9 May 2012 11:48:23 -0400
[Message part 1 (text/plain, inline)]
Helmut Grohne wrote:
> I ask for feedback on this combination of patches. Since the bug is
> assigned to debhelper now, I explicitly pull in the sgml-base
> maintainers (who seem to be MIA).

Right. As I think I've posted before to this bug, I will 
move ahead with the debhelper changes as soon as sgml-base is in
unstable (or perhaps testing).

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#477751; Package debhelper. (Mon, 28 May 2012 14:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Helmut Grohne <helmut@subdivi.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Mon, 28 May 2012 14:51:03 GMT) Full text and rfc822 format available.

Message #214 received at 477751@bugs.debian.org (full text, mbox):

From: Helmut Grohne <helmut@subdivi.de>
To: Joey Hess <joeyh@debian.org>
Cc: 477751@bugs.debian.org, Daniel Leidert <daniel.leidert@wgdd.de>, debian-xml-sgml-pkgs@lists.alioth.debian.org, Ardo van Rangelrooij <ardo@debian.org>
Subject: Re: Bug#477751: tackling this bug
Date: Mon, 28 May 2012 16:48:18 +0200
Hi Joey,

sgml-base 1.26+nmu2 has been accepted in sid. Can you go ahead and
upload debhelper? I talked to the release team and will take care of the
binnmus.

Helmut




Added tag(s) pending. Request was from Joey Hess <joeyh@debian.org> to control@bugs.debian.org. (Mon, 28 May 2012 17:42:11 GMT) Full text and rfc822 format available.

Reply sent to Joey Hess <joeyh@debian.org>:
You have taken responsibility. (Mon, 28 May 2012 18:06:03 GMT) Full text and rfc822 format available.

Notification sent to Jörg Sommer <joerg@alea.gnuu.de>:
Bug acknowledged by developer. (Mon, 28 May 2012 18:06:03 GMT) Full text and rfc822 format available.

Message #221 received at 477751-close@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: 477751-close@bugs.debian.org
Subject: Bug#477751: fixed in debhelper 9.20120528
Date: Mon, 28 May 2012 18:02:23 +0000
Source: debhelper
Source-Version: 9.20120528

We believe that the bug you reported is fixed in the latest version of
debhelper, which is due to be installed in the Debian FTP archive:

debhelper_9.20120528.dsc
  to main/d/debhelper/debhelper_9.20120528.dsc
debhelper_9.20120528.tar.gz
  to main/d/debhelper/debhelper_9.20120528.tar.gz
debhelper_9.20120528_all.deb
  to main/d/debhelper/debhelper_9.20120528_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 477751@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Joey Hess <joeyh@debian.org> (supplier of updated debhelper package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Mon, 28 May 2012 13:40:26 -0400
Source: debhelper
Binary: debhelper
Architecture: source all
Version: 9.20120528
Distribution: unstable
Urgency: low
Maintainer: Joey Hess <joeyh@debian.org>
Changed-By: Joey Hess <joeyh@debian.org>
Description: 
 debhelper  - helper programs for debian/rules
Closes: 477751
Changes: 
 debhelper (9.20120528) unstable; urgency=low
 .
   * dh_installcatalogs: Turn /etc/sgml/$package.cat into conffiles
     and introduce dependency on trigger-based sgml-base. Closes: #477751
     Thanks, Helmut Grohne
Checksums-Sha1: 
 feacaab85a11acb59b1c3dff6c3e3f9abccce5c2 1577 debhelper_9.20120528.dsc
 a2368266acd03653686d43fcdf37d6be946d5049 464083 debhelper_9.20120528.tar.gz
 4cbeef3e5a46ccd2c0dc4a1fbdeecc7552b823b7 700150 debhelper_9.20120528_all.deb
Checksums-Sha256: 
 8e8dd8aac2568d7deedef804d17727ab59dfd4c9865ce2cd72ad12af2033a938 1577 debhelper_9.20120528.dsc
 94fcfdebd474bfc9e73dea20d4fbf0f7ab674e7a2da3f9d5811a54a6fad214a8 464083 debhelper_9.20120528.tar.gz
 f179f2171f2be8d76216429b743d33657629a817d3851f00e3cc2534f7e35958 700150 debhelper_9.20120528_all.deb
Files: 
 720bf992352c11da3db9b225db44d098 1577 devel optional debhelper_9.20120528.dsc
 375d1212bc1f1b263346b4987fda3f75 464083 devel optional debhelper_9.20120528.tar.gz
 5be59cffc962d4bd3c4d93d6759c2975 700150 devel optional debhelper_9.20120528_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIVAwUBT8O5+8kQ2SIlEuPHAQjaDhAAlgCjiuKn9bwpajw9cL272AQcvD44zpJc
k0vQmvxPe3oCSARAv7u70xPTTe9dOiqFMp0ACx6znWT44sJ/9nd9fX4KTEr0/eoc
98F203ovP9WQyCAW4ZZOtDq4dPGi2+To8u0tal+ScQ1H2mt0A3xjv3ndkQjpJkHV
Wd+hiXMzdpW7F6u84RajYuevX3mLFEYAP3eMfjoDDGN8Z25QqEithAhv91KtTv9q
GkloKrwwLvx5c1bmpGfUlfzQWf5Ta74h1J3iBtD9EX5iqDSK0K44M4F/byxH75iW
qChUnZsgGq3zoNdZPHBp+xJHvGsUxgzY6ai4+3kfB7TZrUG3XNyDGx9LzoQRVRkI
SI4bvFyozznDSMBcg4KZxDD/Qrw9n0QUZTzKE/SO3eMaKIjRHUS/OjUzvc80tITj
xQ9zQ/Qyeh57+i1CnhbBDEKROS3QlSnWJmOLT54+1gUQxcYM915BpPSVRirjgdVe
aTU7fz/dFWymbE/MEzeGbiheRDZnpN4zKxLZPXLuhtw4LMhUOGelvQ/rdnbb3nQC
O7f6EzLiLDdgUWGbmy83KwRuuVUtV0iIejLFFkLRUUWHzkrMwugWRVxZJMWlNXhS
oGG3+z+Cs8NdZq2batSfOqWdrgzMfNkDWd9KYxIixQ0X1/i6BVcnKeaZ7fgU1LPY
nNH1k8/1InM=
=a18j
-----END PGP SIGNATURE-----





Reply sent to Joey Hess <joeyh@debian.org>:
You have taken responsibility. (Mon, 28 May 2012 18:06:03 GMT) Full text and rfc822 format available.

Notification sent to Wichert Akkerman <wichert@cistron.nl>:
Bug acknowledged by developer. (Mon, 28 May 2012 18:06:03 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 02 Jun 2013 07:33:33 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 08:50:55 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.